//
//  GLAlertSelectView.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/23.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import IQKeyboardManagerSwift

@objc protocol GLAlertSelectViewDelegate {
    @objc optional func GLAlertSelectViewFinish(sender:UIButton,title:String,cellTag:Int)
    @objc optional func GLAlertSelectDone()
    //普通状态（单多选）
    @objc optional func GLAlertSelectViewClick(selectNum:Int,view:GLAlertSelectView)//单选
    @objc optional func GLAlertMoreSelectViewClick(sender:Array<Int>,view:UIView)//多选
    
    @objc func GLASClose(view:GLAlertSelectView,selectnum:Int,selectArr:Array<Int>)
    //库位专用
    //删除
    @objc optional func GLAlertSelectDelAction(sender:Array<Any>)
    //编辑
    @objc optional func GLAlertSelectEditAction(sender:Int)
    //库位专用
    @objc optional func KuWeiDataArr(sender:Array<Any>)
    
}
class GLAlertSelectView: UIView,UITableViewDelegate,UITableViewDataSource,TitleAndSelectCellDelegate,KuWeiCellCellDelegate,UITextFieldDelegate,GeliAlertViewDelegate{
    func sureGeliAlertViewAction(sender: UIButton) {
        delegate?.GLAlertSelectViewFinish?(sender:sender,title: ysyfTitle,cellTag: cellTag!)
    }
    var isBz = false
    
    var isNonSelect = false {
        didSet {
            var tbvH:CGFloat = 0
            if isNonSelect {
                tbvH = CGFloat((dataArr.count - 1) * 49)
            }else{
                tbvH = CGFloat(dataArr.count * 49)
            }
            if tbvH > fullScreenHeight*0.6 {
                tbvH = fullScreenHeight*0.6
                selectTbv.isScrollEnabled = true
            }
            
            UIView.animate(withDuration: 0.5) {
                self.btmVHeight.constant = 51+tbvH
            }
            
        }
    }
    
    var cellTag:Int?
    var isYsYf = false
    var ysyfTitle = ""
    
    var deSelectArr:Array<Int> = []
    var isOnlySelectKuWei = false
    var isMultipleS:Bool = false
    var contentView:UIView!
    var delegate:GLAlertSelectViewDelegate?
    var inputTextTF:UITextField?
    
    var selectArray:Array<Int>? = []
    var selectNum:Int?
    
    var tempNum:Int?
    var tempArr:Array<Int>? = []
    var selectLblText:String? = ""
    var isShangPinType:Bool = false 
    var kuWeiArr = Array<Any>(){
        didSet{
            var tbvH = CGFloat(kuWeiArr.count * 49)
            if tbvH > fullScreenHeight*0.6 {
                tbvH = fullScreenHeight*0.6
                selectTbv.isScrollEnabled = true
            }
            UIView.animate(withDuration: 0.5) {
                self.btmVHeight.constant = 146.5+tbvH
                if self.btmVHeight.constant > fullScreenHeight*0.75 {
                    self.btmVHeight.constant = fullScreenHeight*0.75
                }
                
            }
        }
    }
    var dataArr = Array<String>(){
        didSet{
            var tbvH = CGFloat(dataArr.count * 49)
        
            if tbvH > fullScreenHeight*0.6 {
                tbvH = fullScreenHeight*0.6
                selectTbv.isScrollEnabled = true
            }
            
            UIView.animate(withDuration: 0.5) {
                self.btmVHeight.constant = 51+tbvH
            }
            
        }
    }
    
    @IBAction func closeAction(_ sender: UIButton) {
        if tempNum == nil {
            tempNum = 10086
        }
        delegate?.GLASClose(view: self, selectnum: tempNum!, selectArr: tempArr!)
    }
    //初始化时将xib中的view添加进来
    @IBOutlet weak var btmView: UIView!
    @IBOutlet weak var btmVHeight: NSLayoutConstraint!
    @IBOutlet weak var titleLbl: UILabel!
    @IBOutlet weak var selectTbv: UITableView!
    //库位
    
    @IBOutlet weak var ipdVHeight: NSLayoutConstraint!
    @IBOutlet weak var inputDataView: UIView!
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        self.setSelectView()
    }
    
    init(frame: CGRect,title:String) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        titleLbl.text = title
        if title.contains("库位") && isOnlySelectKuWei == false{
            self.setKuWeiView()
        }else{
            self.setSelectView()
        }
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        self.setSelectView()
    }
    
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        self.setSelectView()
        return view
    }
    //选择页面
    func setSelectView(){
        
        IQKeyboardManager.shared.resignFirstResponder()
        selectTbv.register(UINib(nibName: "TitleAndSelectCell", bundle: nil), forCellReuseIdentifier: "selectTbvCell")
        btmVHeight.constant = 0
        selectTbv.isScrollEnabled = false
        ipdVHeight.constant = 0.001
    }
    
    func setKuWeiView(){
        IQKeyboardManager.shared.resignFirstResponder()
        
        selectTbv.register(UINib(nibName: "KuWeiCell", bundle: nil), forCellReuseIdentifier: "KuWei")
        btmVHeight.constant = 0
        selectTbv.isScrollEnabled = true
        inputDataView.addSubview(getInputView())
        ipdVHeight.constant = 95.5
    }
    
    //MARK: - cell delegate
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if isNonSelect {
            if indexPath.row == 0{
                return 0.001
            }
        }
        return 49
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if (titleLbl.text?.contains("库位"))! && isOnlySelectKuWei == false{
            return kuWeiArr.count
        }
        return dataArr.count
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        if (titleLbl.text?.contains("库位"))! && isOnlySelectKuWei == false{
            selectNum = indexPath.row
            selectTbv.reloadData()
        }
        let cell = tableView.cellForRow(at: indexPath) as! TitleAndSelectCell
        if  isMultipleS == false {
            
            if isBz {
                if selectNum == cell.tag {
                    selectNum = 10086
                }else{
                    selectNum = cell.tag
                }
            }else{
            
            if isNonSelect {
                if selectNum != 0 {
                    if cell.tag != 0 {
                        selectNum = cell.tag
                    }else{
                        selectNum = tempNum
                    }
                }
            }else{
                selectNum = cell.tag
            }
            }
        }else{
            if isShangPinType {
                if cell.tag == 0 {
                    if selectArray![0] == 99 {
                        selectArray?.insert(0, at: 0)
                        selectArray?.remove(at: 1)
                    }else{
                        selectArray?.insert(99, at: 0)
                        selectArray?.remove(at: 1)
                    }
                }else{
                    for i in 1 ..< selectArray!.count {
                        selectArray?.insert(99, at: i)
                        selectArray?.remove(at: i+1)
                    }
                    selectArray?.insert(cell.tag, at: cell.tag)
                    selectArray?.remove(at: cell.tag+1)
                }
            }else{
                if cell.selectBtn.isSelected == true {
                    selectArray?.insert(99, at: cell.tag)
                    selectArray?.remove(at: cell.tag+1)
                }else{
                    selectArray?.insert(cell.tag, at: cell.tag)
                    selectArray?.remove(at: cell.tag+1)
                }
            }
        }
        selectTbv.reloadData()
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if (titleLbl.text?.contains("库位"))! && isOnlySelectKuWei == false {
            
            let cell = tableView.dequeueReusableCell(withIdentifier: "KuWei") as! KuWeiCell
            cell.delegate = self
            cell.tag = indexPath.row
            let model = kuWeiArr[indexPath.row] as! ShopWarehouseDetailDataPositionModel
            cell.nameTF.text = model.p_name
            cell.nameTF.delegate = self
            cell.nameTF.isUserInteractionEnabled = false
            return cell
        }
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "selectTbvCell") as! TitleAndSelectCell
        cell.titleLbl.text = dataArr[indexPath.row]
        cell.delegate = self
        cell.tag = indexPath.row
        cell.titleLbl.textColor = UIColor(named: "标题字颜色")
        cell.selectBtn.isSelected = false
        
        if isMultipleS == true {
            for item in selectArray! {
                if item == indexPath.row {
                    cell.titleLbl.textColor = UIColor(named: "蓝色字体颜色")
                    cell.selectBtn.isSelected = true
                }
            }
        }else{
            if selectNum == indexPath.row {
                cell.titleLbl.textColor = UIColor(named: "蓝色字体颜色")
                cell.selectBtn.isSelected = true
            }
        }
        
        
        if deSelectArr.count > 0 {
            cell.titleLbl.textColor = UIColor(named: "蓝色字体颜色")
            cell.selectBtn.isSelected = true
            deSelectArr.forEach { (i) in
                if i == indexPath.row{
                    cell.titleLbl.textColor = UIColor(named: "#999999")
                    cell.selectBtn.isUserInteractionEnabled = false
                    cell.selectBtn.isSelected = false
                }
            }
        }
        return cell
    }
    
    
    @IBAction func submitClick(_ sender: Any) {
        
        if (titleLbl.text?.contains("库位"))! && isOnlySelectKuWei == false{
            delegate?.KuWeiDataArr?(sender: kuWeiArr)
            return
        }
        if isMultipleS == false {
            if selectNum == nil && selectNum != 10086{
                HUD.flash(.label("\(titleLbl.text!)"), delay: 1.2)
                return
            }
            if isYsYf {
                if deSelectArr.count > 0 {
                    delegate?.GLAlertSelectDone?()
                    return
                }
                let alertView = GeliAlertView(frame: self.window!.bounds)
                alertView.delegate = self;
                alertView.tishiLbl.text = ""
                alertView.titileLbl.text = "确定设为\(dataArr[selectNum!])?"
                alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
                alertView.rightBtn.tag = selectNum!
                self.window?.addSubview(alertView)
            }else{
                
                delegate?.GLAlertSelectViewClick?(selectNum: selectNum!,view: self)
            }
        }else{
            if selectArray == [99,99,99,99] {
                HUD.flash(.label("\(titleLbl.text!)"), delay: 1.2)
                return
            }
            delegate?.GLAlertMoreSelectViewClick?(sender: selectArray!,view:self)
        }
        
    }
    //MARK: - 自定义CELL DELEGATE
    //普通
    
    func TitleAndSelectCellClick(content: UIButton, cell: TitleAndSelectCell) {
        
        if  isMultipleS == false {
            selectNum = cell.tag
        }else{
            if isShangPinType {
                if cell.tag == 0 {
                    if selectArray![0] == 99 {
                        selectArray?.insert(0, at: 0)
                        selectArray?.remove(at: 1)
                    }else{
                        selectArray?.insert(99, at: 0)
                        selectArray?.remove(at: 1)
                    }
                }else{
                    for i in 1 ..< selectArray!.count {
                        selectArray?.insert(99, at: i)
                        selectArray?.remove(at: i+1)
                    }
                    selectArray?.insert(cell.tag, at: cell.tag)
                    selectArray?.remove(at: cell.tag+1)
                }
            }else{
                if cell.selectBtn.isSelected == true {
                    selectArray?.insert(99, at: cell.tag)
                    selectArray?.remove(at: cell.tag+1)
                }else{
                    selectArray?.insert(cell.tag, at: cell.tag)
                    selectArray?.remove(at: cell.tag+1)
                }
            }
        }
        selectTbv.reloadData()
    }
    var cellIdx:Int?
    var tempName:String = ""
    //库位
    func editClickAction(sender: Int,cell:KuWeiCell) {
        cell.nameTF.isUserInteractionEnabled = !cell.nameTF.isUserInteractionEnabled
        cell.isEditing = cell.nameTF.isUserInteractionEnabled
        cellIdx = cell.tag
        tempName = cell.nameTF.text!
    }
    var isDoneClick = false
    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
        let item = kuWeiArr[cellIdx!] as! ShopWarehouseDetailDataPositionModel
        item.p_name = textField.text
        item.status = 2
        isDoneClick = true
        selectTbv.reloadData()
        return true
    }
    func textFieldDidEndEditing(_ textField: UITextField) {
        let item = kuWeiArr[cellIdx!] as! ShopWarehouseDetailDataPositionModel
        if isDoneClick == false {
            item.p_name = tempName
            item.status = 1
            tempName = ""
            selectTbv.reloadData()
        }
        isDoneClick = false
    }
    
    
    func deleClickAction(sender: Int) {
        if (titleLbl.text?.contains("库位"))! && isOnlySelectKuWei == false{
            kuWeiArr.remove(at: sender)
            delegate?.GLAlertSelectDelAction?(sender: kuWeiArr)
        }else{
            dataArr.remove(at: sender)
            delegate?.GLAlertSelectDelAction?(sender: dataArr)
        }
        selectTbv.reloadData()
    }
    //MARK: - 库位输入界面
    func getInputView()->UIView{
        let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 95.5))
        view.backgroundColor = UIColor.white
        let ti3 = UILabel()
        ti3.text = "操作"
        ti3.textColor = UIColor(named: "灰色字体颜色")
        ti3.font = UIFont.systemFont(ofSize: 13)
        view.addSubview(ti3)
        ti3.sizeToFit()
        ti3.snp.makeConstraints { (make) in
            make.top.equalTo(15)
            make.right.equalTo(-33)
            make.width.equalTo(28)
            make.height.equalTo(18.5)
        }
        
        let ti2 = UILabel()
        ti2.text = "库存数"
        ti2.textColor = UIColor(named: "灰色字体颜色")
        ti2.font = UIFont.systemFont(ofSize: 13)
        view.addSubview(ti2)
        ti2.sizeToFit()
        ti2.snp.makeConstraints { (make) in
            make.top.equalTo(15)
            make.right.equalTo(ti3.snp_left).offset(-80)
            make.width.equalTo(44)
            make.height.equalTo(18.5)
        }
        
        let ti1 = UILabel()
        ti1.text = "库位名称"
        ti1.textColor = UIColor(named: "灰色字体颜色")
        ti1.font = UIFont.systemFont(ofSize: 13)
        view.addSubview(ti1)
        ti1.sizeToFit()
        ti1.snp.makeConstraints { (make) in
            make.top.equalTo(15)
            make.left.equalTo(20)
            make.width.equalTo(60)
            make.height.equalTo(18.5)
        }
        
        let inputTF = UITextField()
        inputTF.addTarget(self, action: #selector(textChange(TF:)), for: .allEditingEvents)
        inputTF.placeholder = "请输入库位名称"
        inputTF.textAlignment = .center
        inputTF.font = UIFont.systemFont(ofSize: 13)
        inputTF.textColor = UIColor(named: "标题字颜色")
        inputTF.borderStyle = .none
        inputTF.layer.cornerRadius = 3
        inputTF.layer.masksToBounds = true
        inputTF.layer.borderColor = UIColor(named: "灰色字体颜色")?.cgColor
        inputTF.layer.borderWidth = 1
        view.addSubview(inputTF)
        inputTF.snp.makeConstraints { (make) in
            make.top.equalTo(ti1.snp_bottom).offset(15)
            make.left.equalTo(15)
            make.width.equalTo(120)
            make.height.equalTo(32)
        }
        inputTextTF = inputTF
        
        let l = UILabel()
        l.text = "-"
        l.font = UIFont.systemFont(ofSize: 13)
        l.textColor = UIColor(named: "灰色字体颜色")
        view.addSubview(l)
        l.snp.makeConstraints { (make) in
            make.centerX.equalTo(ti2.snp_centerX)
            make.centerY.equalTo(inputTF.snp_centerY)
            make.width.height.equalTo(8)
        }
        
        let btn = UIButton()
        btn.setTitle("新增", for: .normal)
        btn.setTitleColor(UIColor(named: "按钮渐变色下,字体颜色"), for: .normal)
        btn.addTarget(self, action: #selector(addKuWei), for: .touchUpInside)
        btn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
        view.addSubview(btn)
        btn.snp.makeConstraints { (make) in
            make.centerX.equalTo(ti3.snp_centerX)
            make.centerY.equalTo(inputTF.snp_centerY)
            make.width.height.equalTo(50)
        }
        
        let lbottom = UIView()
        lbottom.backgroundColor = UIColor(named: "灰色分界线")
        view.addSubview(lbottom)
        lbottom.snp.makeConstraints { (make) in
            make.bottom.left.right.equalTo(0)
            make.height.equalTo(1)
        }
        return view
    }
    @objc func textChange(TF:UITextField){
        
    }
    
    @objc func addKuWei(){
        IQKeyboardManager.shared.resignFirstResponder()
        if (inputTextTF?.text!.count)! > 0 {
            let kuWei = ShopWarehouseDetailDataPositionModel(JSON: ["p_name":inputTextTF!.text!,"p_id":0,"status":4])
            kuWeiArr.append(kuWei!)
            let tbvH = CGFloat(kuWeiArr.count)*49.0
            self.btmVHeight.constant = 146.5+tbvH
            if self.btmVHeight.constant > fullScreenHeight*0.75 {
                self.btmVHeight.constant = fullScreenHeight*0.75
            }
            inputTextTF?.text = ""
            selectTbv?.reloadData()
        }else{
            HUD.flash(.label("请输入库位名称"), delay: 1.2)
        }
    }
}
