//
//  GLMessageAlertView.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/8/19.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class GLMessageAlertView: UIView,UITableViewDelegate,UITableViewDataSource {
    @IBOutlet weak var listView: UITableView!
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return datasArr.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndLblCell") as! TitleAndLblCell
        let str = datasArr[indexPath.row]
        let strs = str.components(separatedBy: ",")
        cell.nameLbl.text = strs.first
        cell.contentLbl.text = strs.last
        if strs.last?.count == 0 {
            cell.contentLbl.text = "--"
        }
        
        return cell
    }
    
    var contentView:UIView!
    
    @IBOutlet weak var topLbl: UILabel!
    @IBOutlet weak var tbvH: NSLayoutConstraint!
    @IBAction func submitAction(_ sender: Any) {
        self.removeFromSuperview()
    }
    var datasArr:Array<String> = []
    @IBOutlet weak var btnLbl: UILabel!
    
    @IBAction func closeAction(_ sender: UIButton) {
        self.removeFromSuperview()
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 49
    }
    
    func setUI(){
        topLbl?.layer.cornerRadius = 5
        topLbl?.layer.maskedCorners = [CACornerMask.layerMinXMinYCorner,CACornerMask.layerMaxXMinYCorner]
        listView.register(UINib(nibName: "TitleAndLblCell", bundle: nil), forCellReuseIdentifier: "TitleAndLblCell")
        listView.separatorStyle = .none
        if datasArr.count * 49 < 147 {
            tbvH.constant = 147
        }
        if CGFloat(datasArr.count) * 49 > CGFloat(fullScreenHeight) * 0.6 {
            tbvH.constant = fullScreenHeight * 0.6
        }
    }
    
    
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.top.left.right.bottom.equalToSuperview()
        }
        setUI()
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        setUI()
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
    
}
