//
//  GeliAlertTextView.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/5/19.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol GeliAlertTextViewDelegate {
    func sureGeliAlertTextViewAction(sender:String)
    
}
class GeliAlertTextView: UIView, UITextViewDelegate {
    var delegate: GeliAlertTextViewDelegate?

    @IBOutlet weak var titleLbl: UILabel!
    @IBOutlet weak var placerLbl: UILabel!
    @IBOutlet weak var textview: UITextView!
    @IBAction func leftAction(_ sender: UIButton) {
        self.removeFromSuperview()
    }
    @IBAction func rightAction(_ sender: UIButton) {
        self.delegate?.sureGeliAlertTextViewAction(sender: textview.text)
        self.removeFromSuperview()
    }
    
    func textViewDidBeginEditing(_ textView: UITextView) {
        placerLbl.isHidden = true
    }
    func textViewDidEndEditing(_ textView: UITextView) {
        if textView.text.count == 0 {
            placerLbl.isHidden = false
        }
    }
    
    var contentView:UIView!

    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        textview.delegate = self
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        textview.delegate = self
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }

}
