//
//  GeliAlertView.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/4/16.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol GeliAlertViewDelegate {
    func sureGeliAlertViewAction(sender:UIButton)
}
class GeliAlertView: UIView {
    @IBOutlet weak var tLbl: UILabel!
    @IBOutlet weak var versionLbl: UILabel!
    @IBOutlet weak var upAppIconV: UIImageView!
    var contentView:UIView!
    var delegate: GeliAlertViewDelegate?
    @IBOutlet weak var titileLbl: UILabel!
    @IBOutlet weak var tishiLbl: UILabel!
    
    @IBOutlet weak var leftBtn: UIButton!
    @IBOutlet weak var rightBtn: UIButton!
    var appStoreVersion:String = ""
    @IBAction func leftAction(_ sender: UIButton) {
     print("左←边按钮响应")
        if appStoreVersion.count != 0 {
            //选择了该版本取消更新后不再提示
//            UserDefaults.standard.setValue(appStoreVersion, forKey: "appStoreVersion")
        }
        self.removeFromSuperview()
    }
    @IBAction func rightAction(_ sender: UIButton) {
        print("右→边按钮响应")
        self.delegate?.sureGeliAlertViewAction(sender: sender)
        self.removeFromSuperview()
    }
    
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
}
