//
//  GeliAltetCodeView.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/6/9.
//  Copyright © 2020 junye lu. All rights reserved.
//

import Foundation
//测试环境为：http://c.gelifood.com
//生产环境为：https://cms.gelifood.com
class GeliAltetCodeView: UIView {
    var saveImgID: Int? = nil{
        didSet{
            saveImg = createQRForString(qrString: "https://cms.gelifood.com/market/src/views/Order/codeDetail.html?order_id=" + StringByInt(number: saveImgID!),
                                        qrImageName: "")
            iconImgV.image = saveImg
        }
    }
    var saveImg: UIImage? = nil
    //创建二维码图片
    func createQRForString(qrString: String?, qrImageName: String?) -> UIImage?{
        if let sureQRString = qrString {
            let stringData = sureQRString.data(using: .utf8,
                                               allowLossyConversion: false)
            // 创建一个二维码的滤镜
            let qrFilter = CIFilter(name: "CIQRCodeGenerator")!
            qrFilter.setValue(stringData, forKey: "inputMessage")
            qrFilter.setValue("H", forKey: "inputCorrectionLevel")
            let qrCIImage = qrFilter.outputImage
            
            // 创建一个颜色滤镜,黑白色
            let colorFilter = CIFilter(name: "CIFalseColor")!
            colorFilter.setDefaults()
            colorFilter.setValue(qrCIImage, forKey: "inputImage")
            colorFilter.setValue(CIColor(red: 0, green: 0, blue: 0), forKey: "inputColor0")
            colorFilter.setValue(CIColor(red: 1, green: 1, blue: 1), forKey: "inputColor1")
            
            // 返回二维码image
            let ciimage = colorFilter.outputImage!
                .transformed(by: CGAffineTransform(scaleX: 5, y: 5))
            let context = CIContext()
            let imageRef = context.createCGImage(ciimage, from: ciimage.extent)
            let codeImage = UIImage(cgImage: imageRef!)
            //            经过一番测试，发现方法[UIImage imageWithCIImage:codeImage];生产的UIImage并不算是实际意义上的图片UIImage.CGImage为nil，而相册保存方法UIImageWriteToSavedPhotosAlbum所保存的就是UIImage.CGImage
            
            // 通常,二维码都是定制的,中间都会放想要表达意思的图片
            if let iconImage = UIImage(named: qrImageName!) {
                let rect = CGRect(x:0, y:0, width:codeImage.size.width,
                                  height:codeImage.size.height)
                UIGraphicsBeginImageContext(rect.size)
                
                codeImage.draw(in: rect)
                let avatarSize = CGSize(width:rect.size.width * 0.25,
                                        height:rect.size.height * 0.25)
                let x = (rect.width - avatarSize.width) * 0.5
                let y = (rect.height - avatarSize.height) * 0.5
                iconImage.draw(in: CGRect(x:x, y:y, width:avatarSize.width,
                                          height:avatarSize.height))
                let resultImage = UIGraphicsGetImageFromCurrentImageContext()
                
                UIGraphicsEndImageContext()
                return resultImage
            }
            
            
            return codeImage
        }
        return nil
    }
    
    @IBOutlet weak var titleLbl: UILabel!
    @IBOutlet weak var outBtn: UIButton!
    @IBAction func outAction(_ sender: UIButton) {
        self.removeFromSuperview()
    }
    @IBOutlet weak var iconImgV: UIImageView!
    @IBAction func dowPhoneAction(_ sender: UIButton) {
        if saveImg == nil {
            HUD.flash(.label("等待图片加载完毕"),delay: 1.2)
            return
        }else{
            let image = self.iconImgV.image!
            print(image)
            UIImageWriteToSavedPhotosAlbum(image, self, #selector(saveImage(image:didFinishSavingWithError:contextInfo:)), nil)
            
        }
        self.removeFromSuperview()
        
    }
    @objc private func saveImage(image: UIImage, didFinishSavingWithError error: NSError?, contextInfo: AnyObject) {
        
        
        
        if error != nil{
            HUD.flash(.label("保存失败"),delay: 1.2)
        }else{
            HUD.flash(.label("保存成功"),delay: 1.2)
        }
        
    }
    //初始化时将xib中的view添加进来
    var contentView:UIView!
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
    
}
