//
//  AddGuiGeCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/23.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import WebKit

@objc protocol AddGuiGeCellDelegate {
    @objc optional func AddGuiGeCellClick(cell:AddGuiGeCell)
    @objc optional func AddGuiGeCellWebViewHeight(height:CGFloat)
}
class AddGuiGeCell: UITableViewCell ,WKNavigationDelegate{
    var delegate:AddGuiGeCellDelegate?
    @IBOutlet weak var btmH: NSLayoutConstraint!
    @IBAction func btnClick(_ sender: Any) {
        delegate?.AddGuiGeCellClick?(cell: self)
    }
    
    @IBOutlet weak var actp: UIActivityIndicatorView!
    
    @IBOutlet weak var webView: WKWebView!
    
    
    @IBOutlet weak var imgBtn: UIButton!
    override func awakeFromNib() {
        super.awakeFromNib()
        selectionStyle = .none
        webView.navigationDelegate = self
        // Initialization code
    }
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    func webView(_ webView: WKWebView, didFinish navigation: WKNavigation!) {
        webView.scrollView.isScrollEnabled = false
        webView.evaluateJavaScript("document.body.scrollHeight") { (result, error) in
            let h = result as! CGFloat
            print("webH = ",h)
            self.actp.stopAnimating()
            self.actp.isHidden = true
            self.delegate?.AddGuiGeCellWebViewHeight?(height:h)
            
        }
        
    }
    
}
