//
//  AddImgCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/23.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import SDWebImage

protocol AddImgCellDelegate {
    func AddImgCellBtnClick(cell:AddImgCell)
    func DelImgCellBtnClick(sender:UIButton,cell:AddImgCell)
    func ChangeCellBtnClick(sender:UIButton,cell:AddImgCell)
}
class AddImgCell: UITableViewCell {
    var delegate:AddImgCellDelegate?
    var isAllEditing = true
    var isEdit:Bool?{
        willSet{
            isEdit = newValue
            if isAllEditing {
                addBtn.isHidden = !isEdit!
            }
        }
    }
    @IBAction func btnClick(_ sender: Any) {
        if isAllEditing {
            delegate?.AddImgCellBtnClick(cell: self)
        }
    }
    var isSingle:Bool?
    
    var imgs:Array<String> = []{
        didSet{
            print(imgs.count)
            if imgs.count > 0{
                if scrollView == nil {
                    let scrView = UIScrollView(frame: CGRect(x: addBtn.frame.minX, y: addBtn.frame.minY, width: fullScreenWidth, height: addBtn.frame.size.height))
                    scrView.showsHorizontalScrollIndicator = false
                    scrView.backgroundColor = UIColor.white
                    self.contentView.addSubview(scrView)
                    scrollView = scrView
                }
                scrollView?.isHidden = false
                
                if isSingle == true {
                    setImgUI(arr: imgs)
                }else{
                    setImgUI(arr: imgs)
                }
            }else{
                scrollView?.isHidden = true
                addBtnX.constant =  15
                if isSingle == true {
                    addBtn.isHidden = false
                }
                
            }
        }
    }
    var scrollView:UIScrollView?
    @IBOutlet weak var addBtn: UIButton!
    @IBOutlet weak var nameLbl: UILabel!
    
    @IBOutlet weak var addBtnX: NSLayoutConstraint!
    func setImgUI(arr:Array<String>){
        let y = addBtn.frame.minY
        let h:CGFloat = addBtn.frame.size.height
        if isSingle == false {
            if isAllEditing {
                addBtn.isHidden = false
            }else{
                addBtn.isHidden = true
            }
            scrollView?.isHidden = false
            scrollView?.bounces = false
            if arr.count < 3 {
                if isAllEditing {
                    addBtn.isHidden = false
                }else{
                    addBtn.isHidden = true
                }
                scrollView?.contentSize = CGSize(width: arr.count*105, height: 0)
               
                    scrollView?.frame = CGRect(x: 15, y: CGFloat(y), width: CGFloat(arr.count)*105, height:h)
                    addBtnX.constant =  (scrollView?.frame.maxX)!
                
            }else if arr.count == 5 {
                addBtn.isHidden = true
                    scrollView?.contentSize = CGSize(width: arr.count*105, height: 0)
                    scrollView?.frame = CGRect(x: 15, y: CGFloat(y), width: fullScreenWidth-30, height:h)
            }else{
                if isAllEditing {
                    scrollView?.frame = CGRect(x: 15, y: CGFloat(y), width: fullScreenWidth-130, height:h)
                    addBtnX.constant =  fullScreenWidth-105
                }else{
                    let w = 90 * CGFloat(arr.count) + (CGFloat(arr.count-1)) * 15
                    var sw = w
                    if w > (fullScreenWidth - 30){
                        sw = fullScreenWidth - 30
                    }
                    scrollView?.frame = CGRect(x: 15, y: CGFloat(y), width: sw,height:h)
                }
                scrollView?.contentSize = CGSize(width: arr.count*105, height: 0)
            }
        }
        for i in 0 ..< arr.count {
            let img = UIImageView()
            img.layer.cornerRadius = 3
            img.layer.masksToBounds = true
            scrollView!.addSubview(img)
            let imgStr = arr[i]
            img.sd_setImage(with: URL(string: SERVERCE_ImageHost + imgStr))
            img.isUserInteractionEnabled = true
            img.snp.makeConstraints { (make) in
                make.centerY.equalTo(scrollView!.snp_centerY)
                make.width.height.equalTo(90)
                make.left.equalTo(105*i)
            }
            
            
            if isAllEditing {
                let changeBtn = UIButton()
                changeBtn.tag = i
                changeBtn.backgroundColor = UIColor(named: "标题字颜色")
                changeBtn.alpha = 0.5
                changeBtn.addTarget(self, action: #selector(changeAction(sender:)), for: .touchUpInside)
                img.addSubview(changeBtn)
                changeBtn.snp.makeConstraints { (make) in
                    make.top.bottom.right.left.equalTo(0)
                }
                
                let ti = UILabel()
                ti.text = "替 换"
                ti.textColor = UIColor.white
                ti.textAlignment = .center
                ti.font = UIFont.systemFont(ofSize: 15)
                img.addSubview(ti)
                ti.snp.makeConstraints { (make) in
                    make.top.bottom.right.left.equalTo(0)
                }
                let delImg = UIImageView()
                img.addSubview(delImg)
                delImg.image = UIImage(named: "shanchuDel")
                delImg.snp.makeConstraints { (make) in
                    make.top.equalTo(img.snp_top).offset(-6)
                    make.right.equalTo(img.snp_right).offset(6)
                    make.width.height.equalTo(15)
                }
                delImg.isHidden = !isEdit!
                
                let delBtn = UIButton()
                delBtn.isUserInteractionEnabled = isEdit!
                scrollView!.addSubview(delBtn)
                delBtn.tag = i
                delBtn.snp.makeConstraints { (make) in
                    make.centerX.equalTo(delImg.snp_centerX)
                    make.centerY.equalTo(delImg.snp_centerY)
                    make.width.height.equalTo(25)
                }
                delBtn.addTarget(self, action: #selector(delAction(sender:)), for: .touchUpInside)
            }
        }
    }
    @objc func changeAction(sender:UIButton){
        if isAllEditing {
            delegate?.ChangeCellBtnClick(sender: sender,cell:self)
        }
    }
    @objc func delAction(sender:UIButton){
        if isAllEditing {
            delegate?.DelImgCellBtnClick(sender:sender, cell: self)
        }
    }
    override func awakeFromNib() {
        super.awakeFromNib()
        selectionStyle = .none
        
        // Initialization code
    }
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
