//
//  CRKCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/5/30.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol CRKCellDelegate {
    func CRKCellBtnClick(sender:UIButton,cell:CRKCell)
}
class CRKCell: UITableViewCell {
    var delegate:CRKCellDelegate?
    @IBOutlet weak var detialView: UIView!//详情底图
    @IBAction func btnClick(_ sender: UIButton) {
        delegate?.CRKCellBtnClick(sender: sender,cell:self)
    }
    @IBOutlet weak var rightBtn: UIButton!
    
    @IBOutlet weak var leftBtn: UIButton!
    @IBOutlet weak var timeLbl: UILabel!
    @IBOutlet weak var countLbl: UILabel!
    @IBOutlet weak var statusNameLbl: UILabel!
    @IBOutlet weak var statusLbl: UILabel!
    @IBOutlet weak var nameLbl: UILabel!
    @IBOutlet weak var btmH: NSLayoutConstraint!
    var status:Int?
    var isGm:Bool?
    var dataArr:Array<WarehouseIoListDataResModel>? = []
    
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        // Initialization code
    }
    override func layoutIfNeeded() {
        detialView.subviews.forEach { (view) in
            view.removeFromSuperview()
        }
        if dataArr != nil {
            var num = 0
            if dataArr!.count > 4 {
                num = 4
            }else{
                num = dataArr!.count
            }
            for i in 0 ..< num {
                let model = dataArr![i]
                let view = UIView()
                detialView.addSubview(view)
                view.backgroundColor = UIColor.white
                view.snp.makeConstraints { (make) in
                    make.top.equalTo(i * 49)
                    make.left.right.equalTo(0)
                    make.height.equalTo(49)
                }
                if i != num - 1 {
                    let dotLine = UIImageView()
                    view.addSubview(dotLine)
                    dotLine.image = UIImage(named: "dotLine")
                    dotLine.snp.makeConstraints { (make) in
                        make.left.equalTo(15)
                        make.bottom.right.equalTo(0)
                        make.height.equalTo(1)
                    }
                }
                let lbl = UILabel()
                lbl.font = UIFont.systemFont(ofSize: 13)
                lbl.textColor = UIColor(named: "灰色字体颜色")
                lbl.text = model.goods_name
                view.addSubview(lbl)
                lbl.snp.makeConstraints { (make) in
                    make.left.equalTo(15)
                    make.bottom.top.right.equalTo(0)
                }
                
                let lbl2 = UILabel()
                lbl2.font = UIFont.systemFont(ofSize: 13)
                lbl2.textColor = UIColor(named: "灰色字体颜色")
                lbl2.text = "x" + "\(model.number!)"
                lbl2.textAlignment = .right
                view.addSubview(lbl2)
                lbl2.snp.makeConstraints { (make) in
                    make.right.equalTo(-15)
                    make.bottom.left.top.equalTo(0)
                }
            }
        }
        super.layoutIfNeeded()
        if status == 1 && isGm == false {
            leftBtn.isHidden = true
            rightBtn.isHidden = true
            btmH.constant = 15
        }else{
            
            if status == 1 {
                leftBtn.isHidden = false
                rightBtn.isHidden = false
                leftBtn.backgroundColor = UIColor.white
                leftBtn.setTitle("通过", for: .normal)
                leftBtn.setTitleColor(UIColor.white, for: .normal)
                leftBtn.isUserInteractionEnabled = true
                leftBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
                leftBtn.layer.cornerRadius = 3
            }else{
                rightBtn.isHidden = true
                leftBtn.isHidden = false
                leftBtn.backgroundColor = UIColor.white
                leftBtn.setTitle("查看详情", for: .normal)
                leftBtn.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
                leftBtn.isUserInteractionEnabled = false
                leftBtn.layer.cornerRadius = 3
                leftBtn.layer.masksToBounds = true
                leftBtn.layer.borderColor = UIColor(named: "蓝色字体颜色")?.cgColor
                leftBtn.layer.borderWidth = 1
                
            }
            btmH.constant = 60
        }
    }
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
