//
//  CommendCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/23.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
@objc protocol CommendCellDelegate {
    @objc optional func CommendCellSendStr(content:String,cell:CommendCell)
    @objc optional func CommendCellSendH(height:CGFloat,cell:CommendCell)
}
class CommendCell: UITableViewCell,AutoTextFieldDelegate{
    var delegate:CommendCellDelegate?
    @IBOutlet weak var editImg: UIImageView!
    @IBOutlet weak var line: UIView!
    @IBOutlet weak var placeLbl: UILabel!
    @IBOutlet weak var titleLbl: UILabel!
    var autoTf:AutoTextField?
    override func awakeFromNib() {
        super.awakeFromNib()
        selectionStyle = .none
        let tap = UITapGestureRecognizer(target: self, action: #selector(tapAction))
        placeLbl.isUserInteractionEnabled = true
        placeLbl.addGestureRecognizer(tap)
        // Initialization code
    }
    
    @objc func tapAction(){
        if autoTf == nil {
            let textV = AutoTextField(frame: CGRect(x: titleLbl.frame.maxX+15, y: 13, width: fullScreenWidth - titleLbl.frame.maxX - editImg.bounds.size.width - 38, height: 18.5), placeholder: "")
            textV.backgroundColor = UIColor.clear
            textV.tfDelegate = self
            textV.textColor = UIColor.black
            textV.textAlignment = .right
            self.contentView.addSubview(textV)
            autoTf = textV
        }
    }
    func sendString(str: String) {
        if str.count > 0 {
            placeLbl.isHidden = true
        }else{
            placeLbl.isHidden = false
        }
        delegate?.CommendCellSendStr?(content: str,cell:self)
    }
    func sendHeight(height: CGFloat) {
        autoTf?.frame = CGRect(x: titleLbl.frame.maxX+15, y: 13, width: fullScreenWidth-titleLbl.frame.maxX - editImg.bounds.size.width - 38, height: height)
        titleLbl.snp.updateConstraints { (make) in
            make.top.equalTo(autoTf!.snp_top)
            make.left.equalTo(15)
            make.right.equalTo(autoTf!.snp_left).offset(-15)
            make.height.equalTo(18.5)
        }
        delegate?.CommendCellSendH?(height: height,cell:self)
    }
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
