//
//  LalamoveBillTableViewCell.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/8/8.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class LalamoveBillTableViewCell: UITableViewCell {
    @IBOutlet weak var coverLbl: UILabel!
    @objc func imgBtnClick(sender: UITapGestureRecognizer) {
         let browser = JXPhotoBrowser()
               browser.numberOfItems = {
                self.datasArr!.count
               }
               var url:URL?
            browser.pageIndex = sender.view?.tag as! Int
               //商家协议 SERVERCE_ImageHost
               browser.reloadCellAtIndex = { context in
                url = URL(string:self.datasArr![context.index])
                   let browserCell = context.cell as? JXPhotoBrowserImageCell
                   // 用SDWebImage加载
                   browserCell?.imageView.sd_setImage(with: url, placeholderImage: nil, options: [], completed: { (_, _, _, _) in
                       browserCell?.setNeedsLayout()
                   })
               }
               browser.show()
    }
    var datasArr:Array<String>?
    
    @IBOutlet weak var rightBtn: UIImageView!
    @IBOutlet weak var middleBtn: UIImageView!
    @IBOutlet weak var leftBtn: UIImageView!
    @IBOutlet weak var nameLbl: UILabel!
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        let tap = UITapGestureRecognizer(target: self, action: #selector(imgBtnClick(sender:)))
        leftBtn.addGestureRecognizer(tap)
        let tap1 = UITapGestureRecognizer(target: self, action: #selector(imgBtnClick(sender:)))
        middleBtn.addGestureRecognizer(tap1)
        let tap2 = UITapGestureRecognizer(target: self, action: #selector(imgBtnClick(sender:)))
        rightBtn.addGestureRecognizer(tap2)
        let tap3 = UITapGestureRecognizer(target: self, action: #selector(imgBtnClick(sender:)))
        coverLbl.addGestureRecognizer(tap3)
    }
    override func layoutSubviews() {
        super.layoutSubviews()
        if datasArr == nil {
            return
        }
        coverLbl.isHidden = true
        switch datasArr?.count {
        case 1://SERVERCE_ImageHost +
            leftBtn!.sd_setImage(with:URL(string:datasArr![0]), placeholderImage: UIImage.init(named: "worktest1"))
            
            middleBtn.isHidden = true
            rightBtn.isHidden = true
            break
        case 2:
            leftBtn!.sd_setImage(with:URL(string: datasArr![0]), placeholderImage: UIImage.init(named: "worktest1"))
            middleBtn!.sd_setImage(with:URL(string:datasArr![1]), placeholderImage: UIImage.init(named: "worktest1"))
            rightBtn.isHidden = true
            break
        case 3:
            for i in 0 ..< datasArr!.count {
                switch i {
                case 0:
                    leftBtn.sd_setImage(with:URL(string: datasArr![i]), placeholderImage: UIImage.init(named: "worktest1"))
                    break
                case 1:
                    middleBtn.sd_setImage(with:URL(string: datasArr![i]), placeholderImage: UIImage.init(named: "worktest1"))
                    break
                default:
                    rightBtn.sd_setImage(with:URL(string: datasArr![i]), placeholderImage: UIImage.init(named: "worktest1"))
                    break
                }
            }
            break
        default:
            leftBtn!.sd_setImage(with:URL(string: datasArr![0]), placeholderImage: UIImage.init(named: "worktest1"))
            middleBtn!.sd_setImage(with:URL(string: datasArr![1]), placeholderImage: UIImage.init(named: "worktest1"))
            rightBtn!.sd_setImage(with:URL(string: datasArr![2]), placeholderImage: UIImage.init(named: "worktest1"))
            coverLbl.isHidden = false
            coverLbl.text = "+\(datasArr!.count - 3)"
            break
        }
        
        
    }
    
    
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
