//
//  UpBillDataTableViewCell.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/8/8.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol UpBillDataTableViewCellDelegate {
    func segmentChangeIndex(index:Int)
    func UpBillDataTableViewCellSelectString(selectString:String,inputString:String)
}
class UpBillDataTableViewCell: UITableViewCell, UITextFieldDelegate {
    var delegate:UpBillDataTableViewCellDelegate?

    @IBOutlet weak var selectSegmentV: UISegmentedControl!
    
    @IBOutlet weak var updataBtn: UIButton!
    @IBOutlet weak var upDataTLbl: UILabel!
    @IBOutlet weak var inputInfoTF: UITextField!
    @IBOutlet weak var inputInfoTfBgV: UIView!
    @IBOutlet weak var billNumLbl: UILabel!
    
    //查看发票信息
    @IBAction func checkBillDetailAction(_ sender: UIButton) {
        print("//查看发票信息")
        delegate?.UpBillDataTableViewCellSelectString(selectString: "查看发票信息", inputString: "")
    }
    //通知用户
    @IBAction func noticUserAction(_ sender: UIButton) {
        print("//通知用户")
        delegate?.UpBillDataTableViewCellSelectString(selectString: "通知用户", inputString: "")

    }
    //上传发票
    @IBAction func updataAction(_ sender: UIButton) {
        print("//上传发票")
        delegate?.UpBillDataTableViewCellSelectString(selectString: "上传发票", inputString: "")
    }
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        let redAttribute = [NSAttributedString.Key.foregroundColor: UIColor.white,NSAttributedString.Key.font: UIFont.systemFont(ofSize: 13)] as [NSAttributedString.Key : Any]
        selectSegmentV.setTitleTextAttributes(redAttribute, for: .selected)
        
        let redAttribute1 = [NSAttributedString.Key.foregroundColor: UIColor.init(named: "灰色字体颜色") as Any,NSAttributedString.Key.font: UIFont.systemFont(ofSize: 13)] as [NSAttributedString.Key : Any]
        selectSegmentV.setTitleTextAttributes(redAttribute1, for: .normal)
        
        selectSegmentV.addTarget(self, action: #selector(sementedControlClick), for: .valueChanged)
        
        inputInfoTF.delegate = self
    }
    @objc func sementedControlClick() {
        print("selectindex",selectSegmentV.selectedSegmentIndex)
        delegate?.segmentChangeIndex(index: selectSegmentV.selectedSegmentIndex)
    }
    func textFieldDidEndEditing(_ textField: UITextField) {
        print("end input",textField.text!)
        delegate?.UpBillDataTableViewCellSelectString(selectString: "上传链接地址", inputString: textField.text!)
    }
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
