//
//  HeaderSelectView.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/4/22.
//  Copyright © 2020 junye lu. All rights reserved.
//

import Foundation
protocol HeaderSelectViewDelegate {
    // 协议定义
    func showAction(sender:Int)
    func colseAction(sender:Int)
    
}

class HeaderSelectView: UIView {
    var delegate:HeaderSelectViewDelegate?
    
    
    @IBOutlet weak var firstBtn: UIButton!
    @IBOutlet weak var secBtn: UIButton!
    @IBOutlet weak var thereBtn: UIButton!
    
    var contentView:UIView!
    let upImg = UIImage.init(named: "shangla")
    let dowImg = UIImage.init(named: "xiala")
    let upColor = UIColor.init(named: "蓝色字体颜色")
    let dowColor = UIColor.init(named: "标题字颜色")
    
    
    @IBAction func fristBtnAction(_ sender: UIButton) {
        if sender.titleColor(for: .normal) == upColor {
            sender.setTitleColor(dowColor, for: .normal)
            sender.setImage(dowImg, for: .normal)
            self.delegate?.colseAction(sender: 0)
        }else{
            sender.setTitleColor(upColor, for: .normal)
            sender.setImage(upImg, for: .normal)
            
            secBtn.setTitleColor(upColor, for: .normal)
            secBtnAction(secBtn)
            if thereBtn != nil {
                thereBtn.setTitleColor(upColor, for: .normal)
                thereBtnAction(thereBtn)
            }
            
            self.delegate?.showAction(sender: 0)
            
        }
        
    }
    
    @IBAction func secBtnAction(_ sender: UIButton) {
        if sender.titleColor(for: .normal) == upColor {
            sender.setTitleColor(dowColor, for: .normal)
            sender.setImage(dowImg, for: .normal)
            self.delegate?.colseAction(sender: 1)
            
        }else{
            sender.setTitleColor(upColor, for: .normal)
            sender.setImage(upImg, for: .normal)
            
            firstBtn.setTitleColor(upColor, for: .normal)
            if thereBtn != nil {
                thereBtn.setTitleColor(upColor, for: .normal)
                thereBtnAction(thereBtn)
            }
            fristBtnAction(firstBtn)
            self.delegate?.showAction(sender: 1)
            
        }
    }
    
    @IBAction func thereBtnAction(_ sender: UIButton) {
        if sender.titleColor(for: .normal) == upColor {
            sender.setTitleColor(dowColor, for: .normal)
            sender.setImage(dowImg, for: .normal)
            self.delegate?.colseAction(sender: 2)
            
        }else{
            sender.setTitleColor(upColor, for: .normal)
            sender.setImage(upImg, for: .normal)
            
            firstBtn.setTitleColor(upColor, for: .normal)
            secBtn.setTitleColor(upColor, for: .normal)
            fristBtnAction(firstBtn)
            secBtnAction(secBtn)
            self.delegate?.showAction(sender: 2)
            
        }
    }
    func colseBytitleArr(arr:[String],index:Int){
        if arr.count > 0 {
            let str1 = arr[0] + " "
            if index == 0 {
                firstBtn.setTitle(str1, for: .normal)
            }else if index == 1{
                secBtn.setTitle(str1, for: .normal)
            }else if index == 2{
                thereBtn.setTitle(str1, for: .normal)
            }
        }
        firstBtn.setTitleColor(dowColor, for: .normal)
        secBtn.setTitleColor(dowColor, for: .normal)
        if thereBtn != nil {
            thereBtn.setTitleColor(dowColor, for: .normal)
            thereBtn.setImage(dowImg, for: .normal)
        }
        firstBtn.setImage(dowImg, for: .normal)
        secBtn.setImage(dowImg, for: .normal)
    }
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
}

