//
//  LogisticalSelectView.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/7/27.
//  Copyright © 2020 junye lu. All rights reserved.
//

import Foundation
import LGButton

protocol LogisticalSelectViewDelegate {
    func LogisticalSelectViewSure(index:Int)
    func LogisticalSelectViewWebBy(index:Int)
    func LogisticalSelectViewBtnclick(idx:Int)
}

class LogisticalSelectView: UIView {
    var delegate:LogisticalSelectViewDelegate?
    @IBOutlet weak var jdBgViewH: NSLayoutConstraint!
    @IBOutlet weak var jdSelectBtn: UIButton!
    @IBOutlet weak var sfSelectBtn: UIButton!
    @IBOutlet weak var xySelectBtn: UIButton!
    @IBOutlet weak var sfBgViewH: NSLayoutConstraint!
    @IBOutlet weak var sfBgView: UIView!
    
    @IBAction func blackAction(_ sender: Any) {
        self.removeFromSuperview()
    }
    @IBOutlet weak var selectBgView: UIView!
    @IBOutlet weak var selectBgHeight: NSLayoutConstraint!
    @IBOutlet weak var sfAgreeLbl: UILabel!
    @IBOutlet weak var xingYuanBgV: UIView!
    @IBOutlet weak var xingYuanBgHeight: NSLayoutConstraint!
    
    @IBOutlet weak var xyPriceLbl: UILabel!
    @IBOutlet weak var sflineBottom: NSLayoutConstraint!
    @IBOutlet weak var xyTop: NSLayoutConstraint!
    @IBOutlet weak var xyAgreeLbl: UILabel!
    @IBOutlet weak var sfPriceLbl: UILabel!
    @IBOutlet weak var jdPriceLbl: UILabel!
    var SFtempArr:Array<UILabel> = []
    var SFfuTitleArr:Array<String> = [] {
        didSet {
            if SFfuTitleArr.count == 0 {
                SFtempArr.forEach { (item) in
                    item.removeFromSuperview()
                }
                selectBgHeight.constant = CGFloat(270)
                xyTop.constant = CGFloat(0)
                sflineBottom.constant = CGFloat(0)

                return
            }
            for i in 0..<SFfuTitleArr.count {
                let lbl = UILabel()
                lbl.text = SFfuTitleArr[i]
                lbl.textColor = UIColor.init(named: "提示语字体颜色")
                lbl.font = UIFont.systemFont(ofSize: 11)
                selectBgView.addSubview(lbl)
                lbl.snp.makeConstraints { (make) in
                    make.left.equalTo(sfAgreeLbl)
                    make.top.equalTo(sfAgreeLbl.snp_bottom).offset((5 + 15) * i + 5)
                }
                SFtempArr.append(lbl)
            }
            xyTop.constant = CGFloat(SFfuTitleArr.count * 19)
            sflineBottom.constant = CGFloat(-(SFfuTitleArr.count * 19))
            
            selectBgHeight.constant = CGFloat(270 + SFfuTitleArr.count * 19)
        }
    }
    
    var XYtempArr:Array<UILabel> = []
    var XYfuTitleArr:Array<String> = [] {
        didSet {
            if XYfuTitleArr.count == 0 {
                XYtempArr.forEach { (item) in
                    item.removeFromSuperview()
                }
                selectBgHeight.constant = CGFloat(270)
                return
            }
            for i in 0..<XYfuTitleArr.count {
                let lbl = UILabel()
                lbl.text = XYfuTitleArr[i]
                lbl.textColor = UIColor.init(named: "提示语字体颜色")
                lbl.font = UIFont.systemFont(ofSize: 11)
                selectBgView.addSubview(lbl)
                lbl.snp.makeConstraints { (make) in
                    make.left.equalTo(xyAgreeLbl)
                    make.top.equalTo(xyAgreeLbl.snp_bottom).offset((5 + 15) * i + 5)
                }
                XYtempArr.append(lbl)
            }
            selectBgHeight.constant = CGFloat(270 + XYfuTitleArr.count * 19)
        }
    }
    
   
    @IBAction func xiadanAction(_ sender: Any) {
        if jdSelectBtn.isSelected || sfSelectBtn.isSelected  || xySelectBtn.isSelected{
            if jdSelectBtn.isSelected {
             
                delegate?.LogisticalSelectViewSure(index: 1)
            }else if sfSelectBtn.isSelected {
               
                delegate?.LogisticalSelectViewSure(index: 2)
            }else if xySelectBtn.isSelected {
               
                delegate?.LogisticalSelectViewSure(index: 12)
            }
            self.removeFromSuperview()
        }else{
            HUD.flash(.label("请选择下单物流"),delay: 1.2)
        }

    }
 
    @IBAction func kuaijianAction(_ sender: UIButton) {
        if sender.tag == 0 {
            print("京东快件服务协议")
        }else if sender.tag == 1 {
            print("顺丰快件服务协议")
        }else if sender.tag == 12 {
            print("鑫源物流服务协议")
        }
        delegate?.LogisticalSelectViewWebBy(index: sender.tag)

    }
    
    @IBAction func selectTheLogisticalAction(_ sender: UIButton) {
        if sender == jdSelectBtn {
            jdSelectBtn.isSelected = !jdSelectBtn.isSelected
            sfSelectBtn.isSelected = false
            xySelectBtn.isSelected = false
            delegate?.LogisticalSelectViewBtnclick(idx: 0)

        }else if sender == sfSelectBtn {
            sfSelectBtn.isSelected = !sfSelectBtn.isSelected
            jdSelectBtn.isSelected = false
            xySelectBtn.isSelected = false
            if sfSelectBtn.isSelected {
                delegate?.LogisticalSelectViewBtnclick(idx: 1)
            }else{
                delegate?.LogisticalSelectViewBtnclick(idx: 0)
            }
        }else if sender == xySelectBtn {
            xySelectBtn.isSelected = !xySelectBtn.isSelected
            jdSelectBtn.isSelected = false
            sfSelectBtn.isSelected = false
            if xySelectBtn.isSelected {
                delegate?.LogisticalSelectViewBtnclick(idx: 3)
            }else{
                delegate?.LogisticalSelectViewBtnclick(idx: 0)
            }
        }
        
    }
    @IBOutlet weak var jdBgView: UIView!
    var contentView:UIView!

    func setXingYuan(){
        xingYuanBgV.isHidden = true
        xingYuanBgHeight.constant = 0
    }
    func setJD(){
        jdBgViewH.constant = 0
        jdBgView.isHidden = true
        selectBgHeight.constant = CGFloat(270)

    }
    func setSF(){
        sfBgViewH.constant = 0
        sfBgView.isHidden = true
    }
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
}
