//
//  MoreAndTimeSelectView.swift
//  GeliBusinessPlatform
//
//  Created by liujunhong on 2020/6/2.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol MoreAndTimeSelectViewDelegate {
    func sureActionMoreAndTimeSelectView(beginDate: Date?, endginDate: Date?,paySelectArr:Array<Bool>,bugSelectArr:Array<Bool>,sendSelectArr:Array<Bool>)
    func colseActionMoreAndTimeSelectView()
}
class MoreAndTimeSelectView: UIView, TitleAndSelCalendarViewDelegate, TimeSelectViewDelgate {
    @IBOutlet weak var contentWidht: NSLayoutConstraint!
    @IBOutlet weak var contentHeight: NSLayoutConstraint!
    @IBOutlet weak var contenV: UIView!
    var contentView:UIView!
    var delegate:MoreAndTimeSelectViewDelegate?
    
    @IBOutlet weak var scrollview: UIScrollView!
    @IBOutlet weak var showViewHeight: NSLayoutConstraint!
    @IBAction func resetAction(_ sender: UIButton) {
        //重置
        calendarV.clearTheSelect()
        contenV.subviews.forEach { (view) in
            view.removeFromSuperview()
        }
        
        BeginDate = nil
        EndDate = nil
        paySArr = [true,false,false,false]
        bugSArr = [true,false,false]
        sendSArr = []
        setUI()

        setUIbyData(beginDate: BeginDate, endginDate: EndDate, paySelectArr: paySArr, bugSelectArr: bugSArr, sendSelectArr: sendSArr)
        self.delegate?.sureActionMoreAndTimeSelectView(beginDate: BeginDate, endginDate: EndDate, paySelectArr: paySArr, bugSelectArr: bugSArr, sendSelectArr: sendSArr)
        
    }
    
    
    @IBAction func sureAction(_ sender: UIButton) {
        //确定
        self.removeFromSuperview()
        self.delegate?.sureActionMoreAndTimeSelectView(beginDate: BeginDate, endginDate: EndDate, paySelectArr: paySArr, bugSelectArr: bugSArr, sendSelectArr: sendSArr)
        
    }
    
    @IBAction func blackTapAction(_ sender: UITapGestureRecognizer) {
        //点击黑色部分隐藏
        self.removeFromSuperview()
        self.delegate?.colseActionMoreAndTimeSelectView()
        
    }
    //setUI-前必传
    //MARK:--数据源
    var BeginDate: Date! = nil
    var EndDate: Date! = nil
    var paySArr:Array<Bool> = [false,false,false,false]
    var bugSArr:Array<Bool> = [false,false,false]
    var sendSArr:Array<Bool> = []
    
    var contentH = 320*glscale
    
    let line1 = UIView()
    let timeTilelV = TitleAndSelCalendarView()
    let calendarV = TimeSelectView(frame: CGRect(x: 0, y: 85*glscale, width: fullScreenWidth, height: 235*glscale))
    let line3 = UIView()

    func setUI(){
        contentWidht.constant = 375*glscale
        contentH = 320*glscale
        contentHeight.constant = contentH
        showViewHeight.constant = contentH + 50*glscale
        
        timeTilelV.delegate = self
        contenV.addSubview(timeTilelV)
        timeTilelV.timeLbl.text = "请选择时间范围"
        timeTilelV.isSelectV = false
        timeTilelV.snp.makeConstraints { (make) in
            make.left.top.equalTo(15*glscale)
            make.right.equalTo(-135*glscale)
            make.height.equalTo(60*glscale)
        }
        
        //分界线1
        line1.backgroundColor = UIColor.init(named: "灰色分界线")
        contenV.addSubview(line1)
        line1.snp.makeConstraints { (make) in
            make.left.right.equalTo(0)
            make.height.equalTo(1)
            make.top.equalTo(timeTilelV.snp_bottom).offset(15*glscale)
        }
        
        let payV = addTitleAndMoreBtn(title: "审核状态", arrStr: ["全部","待审核","已通过","未通过"], btnTag: 1000)
        contenV.addSubview(payV)
        payV.snp.makeConstraints { (make) in
            make.left.equalTo(15*glscale)
            make.top.equalTo(line1.snp_bottom).offset(15*glscale)
            make.right.equalTo(0)
            make.height.equalTo(60*glscale)
        }
        //分界线2
        let line2 = UIView()
        line2.backgroundColor = UIColor.init(named: "灰色分界线")
        contenV.addSubview(line2)
        line2.snp.makeConstraints { (make) in
            make.left.right.equalTo(0)
            make.height.equalTo(1)
            make.top.equalTo(payV.snp_bottom).offset(15*glscale)
        }
        let typeV = addTitleAndMoreBtn(title: "出库类型", arrStr: ["全部","入库","出库"], btnTag: 2000)
        contenV.addSubview(typeV)
        typeV.snp.makeConstraints { (make) in
            make.left.equalTo(15*glscale)
            make.top.equalTo(line2.snp_bottom).offset(15*glscale)
            make.right.equalTo(0)
            make.height.equalTo(60*glscale)
        }
        //分界线3
        line3.backgroundColor = UIColor.init(named: "灰色分界线")
        contenV.addSubview(line3)
        line3.snp.makeConstraints { (make) in
            make.left.right.equalTo(0)
            make.height.equalTo(1)
            make.top.equalTo(typeV.snp_bottom).offset(15*glscale)
        }
        let statusV = addTitleAndMoreBtn(title: "具体类型", arrStr: [], btnTag: 3000)
        contenV.addSubview(statusV)
        statusV.tag = 10086
        statusV.snp.makeConstraints { (make) in
            make.left.equalTo(15*glscale)
            make.top.equalTo(line3.snp_bottom).offset(15*glscale)
            make.right.equalTo(0)
            make.height.equalTo(20*glscale)
        }
        
    }
    
    //如果展示时间选择器，就 + 235*glscale
    //MARK:--展示日历选择器
    var isShowCalendarV = false
    func isShowCalendarV(isShow: Bool) {
        if isShow {
            isShowCalendarV = true
            contentH = contentH + 235*glscale
            contentHeight.constant = contentH
            calendarV.moreSelection = true
            contenV.addSubview(calendarV)
            calendarV.delegate = self
            line1.snp.remakeConstraints { (make) in
                make.left.right.equalTo(0)
                make.height.equalTo(1)
                make.top.equalTo(calendarV.snp_bottom)
            }
            if BeginDate != nil {
                calendarV.setOldDate(beginD: BeginDate!, endD: EndDate!)
            }
        }else{
            isShowCalendarV = false
            contentH = contentH - 235*glscale
            contentHeight.constant = contentH
            calendarV.removeFromSuperview()
            line1.snp.remakeConstraints { (make) in
                make.left.right.equalTo(0)
                make.height.equalTo(1)
                make.top.equalTo(timeTilelV.snp_bottom).offset(15*glscale)
            }
        }
    }
    
    //MARK:--日历代理
    func selectMoreDate(beginDate: Date, endginDate: Date) {
        //bug
        let timeInterval:TimeInterval = beginDate.timeIntervalSince1970
        let timeIntervalEnd:TimeInterval = endginDate.timeIntervalSince1970
        
        timeTilelV.timeLbl.text = dayByDouble(sender: timeInterval) + "-" + dayByDouble(sender: timeIntervalEnd)
        EndDate = endginDate
        BeginDate = beginDate
        
    }
    //MARK--标题和按钮多的情况1
    var allSelectBtn : Array<UIButton> = []
    
    func addTitleAndMoreBtn(title:String,arrStr:[String],btnTag:Int) -> UIView {
        let conView = UIView()
        
        let titleLbl = UILabel()
        titleLbl.textColor = UIColor.init(named: "标题字颜色")
        titleLbl.font = UIFont.systemFont(ofSize: 13)
        conView.addSubview(titleLbl)
        titleLbl.snp.makeConstraints { (make) in
            make.left.top.equalTo(0)
        }
        titleLbl.text = title
        if title == "具体类型" {
            let tishiLbl = UILabel()
            tishiLbl.textColor = UIColor.init(named: "灰色字体颜色")
            tishiLbl.font = UIFont.systemFont(ofSize: 11)
            conView.addSubview(tishiLbl)
            tishiLbl.snp.makeConstraints { (make) in
                make.bottom.equalTo(titleLbl)
                make.left.equalTo(titleLbl.snp_right).offset(3)
            }
            tishiLbl.text = "(需选择出入库类型)"
            let tempBtnArr = allSelectBtn
            allSelectBtn.removeAll()
            tempBtnArr.forEach { (sender) in
                if sender.tag < 3000 {
                    allSelectBtn.append(sender)
                }
            }
        }
        weak var btn:UIButton? = nil
        for i in 0 ..< arrStr.count {
            let str = arrStr[i]
            let selectBtn = UIButton(type: .custom)
            conView.addSubview(selectBtn)
            selectBtn.setTitle(str, for: .normal)
            selectBtn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
            selectBtn.setTitleColor(UIColor.init(named: "多选按钮字体颜色"), for: .normal)
            selectBtn.backgroundColor = UIColor.init(named: "多选按钮背景颜色")
            selectBtn.layer.cornerRadius = 3
            selectBtn.snp.makeConstraints { (make) in
                if i < 4 {
                    make.left.equalTo(CGFloat(CGFloat(i * (73 + 15)) * glscale))
                    make.top.equalTo(titleLbl.snp_bottom).offset(10*glscale)
                    btn = selectBtn
                }else if i < 8 {
                    make.left.equalTo(CGFloat(CGFloat((i - 4) * (73 + 15)) * glscale))
                    make.top.equalTo(btn!.snp_bottom).offset(10*glscale)
                    if i == 7 {
                        btn = selectBtn
                    }
                }else{
                    make.left.equalTo(CGFloat(CGFloat((i - 8) * (73 + 15)) * glscale))
                    make.top.equalTo(btn!.snp_bottom).offset(10*glscale)
                }
                make.width.equalTo(73*glscale)
                make.height.equalTo(30*glscale)
            }
            selectBtn.addTarget(self, action: #selector(selectBtnAction(sender:)), for: .touchUpInside)
            selectBtn.tag = btnTag + i
            allSelectBtn.append(selectBtn)
        }
        
        return conView
    }
    
    @objc func selectBtnAction(sender:UIButton) {
        sender.isSelected = !sender.isSelected
        if sender.isSelected {
            sender.setTitleColor(UIColor.init(named: "白色背景色"), for: .normal)
            sender.backgroundColor = UIColor.init(named: "蓝色字体颜色")
        }else{
            sender.setTitleColor(UIColor.init(named: "多选按钮字体颜色"), for: .normal)
            sender.backgroundColor = UIColor.init(named: "多选按钮背景颜色")
        }
        
        if sender.tag < 2000 {
            let index = sender.tag - 1000
            paySArr = [false,false,false,false]
            allSelectBtn.forEach { (btn) in
                if btn.tag < 2000 && btn.tag > 999 {
                    if btn.tag != sender.tag {
                        btn.isSelected = false
                        btn.setTitleColor(UIColor.init(named: "多选按钮字体颜色"), for: .normal)
                        btn.backgroundColor = UIColor.init(named: "多选按钮背景颜色")
                    }
                }
            }
            paySArr[index] = sender.isSelected
            
        }else if sender.tag < 3000 {
            let index = sender.tag - 2000
            bugSArr = [false,false,false]
            allSelectBtn.forEach { (btn) in
                if btn.tag < 3000 && btn.tag > 1999 {
                    if btn.tag != sender.tag {
                        btn.isSelected = false
                        btn.setTitleColor(UIColor.init(named: "多选按钮字体颜色"), for: .normal)
                        btn.backgroundColor = UIColor.init(named: "多选按钮背景颜色")
                    }
                }
            }
            bugSArr[index] = sender.isSelected
            

            if index > 0 && sender.isSelected{
                let suv = contenV.viewWithTag(10086)
                suv?.removeFromSuperview()
                //选择了出入库
                
                print("选择了出入库")
                if sendSArr.count == 0 {
                    contentH = contentH + 120*glscale
                    contentHeight.constant = contentH
                }
                
                if index == 1{
                    let arrStr = ["全部","采购","调入","退货","生产","调出被拒绝","外采","其他","固定采购","临时采购"]
                    sendSArr.removeAll()
                    arrStr.forEach { (str) in
                        sendSArr.append(false)
                    }
                    let statusV = addTitleAndMoreBtn(title: "具体类型", arrStr: arrStr, btnTag: 3000)
                    contenV.addSubview(statusV)
                    statusV.tag = 10086
                    statusV.snp.makeConstraints { (make) in
                        make.left.equalTo(15*glscale)
                        make.top.equalTo(line3.snp_bottom).offset(15*glscale)
                        make.right.equalTo(0)
                        make.height.equalTo(140*glscale)
                    }
                }else{
                    let arrStr = ["全部","销售","调出","报损","赠品","自用","生产使用","过期处理","用户试用","采购退货","其他"]
                    sendSArr.removeAll()
                    arrStr.forEach { (str) in
                        sendSArr.append(false)
                    }
                    let statusV = addTitleAndMoreBtn(title: "具体类型", arrStr:arrStr,  btnTag: 3000)
                    contenV.addSubview(statusV)
                    statusV.tag = 10086
                    statusV.snp.makeConstraints { (make) in
                        make.left.equalTo(15*glscale)
                        make.top.equalTo(line3.snp_bottom).offset(15*glscale)
                        make.right.equalTo(0)
                        make.height.equalTo(140*glscale)
                    }
                }

                var offsetH  = 120*glscale
                if  isShowCalendarV {
                    offsetH = offsetH + 235*glscale
                }
                scrollview.setContentOffset(CGPoint(x: 0, y: offsetH), animated: true)
                
            }else{
                print("选择全部")
                if sendSArr.count > 0 {
                    let suv = contenV.viewWithTag(10086)
                    suv?.removeFromSuperview()
                    let statusV = addTitleAndMoreBtn(title: "具体类型", arrStr: [], btnTag: 3000)
                    sendSArr = []
                    contenV.addSubview(statusV)
                    statusV.tag = 10086
                    statusV.snp.makeConstraints { (make) in
                        make.left.equalTo(15*glscale)
                        make.top.equalTo(line3.snp_bottom).offset(15*glscale)
                        make.right.equalTo(0)
                        make.height.equalTo(20*glscale)
                    }
                    contentH = contentH - 120*glscale
                    contentHeight.constant = contentH
                }

            }
            
        }else{
            let index = sender.tag - 3000
            var tmpeArr:[Bool] = []
            sendSArr.forEach { (isb) in
                tmpeArr.append(false)
            }
            sendSArr = tmpeArr
            allSelectBtn.forEach { (btn) in
                if btn.tag < 4000 && btn.tag > 2999 {
                    if btn.tag != sender.tag {
                        btn.isSelected = false
                        btn.setTitleColor(UIColor.init(named: "多选按钮字体颜色"), for: .normal)
                        btn.backgroundColor = UIColor.init(named: "多选按钮背景颜色")
                    }
                }
            }
            
            sendSArr[index] = sender.isSelected
        }
        
    }
    func setUIbyData (beginDate: Date?, endginDate: Date?, paySelectArr: Array<Bool>, bugSelectArr: Array<Bool>, sendSelectArr: Array<Bool>) {
        EndDate = endginDate
        BeginDate = beginDate
        self.paySArr = paySelectArr
        self.bugSArr = bugSelectArr
        self.sendSArr = sendSelectArr
        if BeginDate == nil {
            timeTilelV.timeLbl.text = "请选择时间范围"
        }else{
            
            let timeInterval:TimeInterval = BeginDate.timeIntervalSince1970
            let timeIntervalEnd:TimeInterval = EndDate.timeIntervalSince1970
            
            timeTilelV.timeLbl.text = dayByDouble(sender: timeInterval) + "," + dayByDouble(sender: timeIntervalEnd)
        }
        if sendSelectArr.count > 0 {
            let suv = contenV.viewWithTag(10086)
            suv?.removeFromSuperview()
            
            contentH = contentH + 120*glscale
            contentHeight.constant = contentH
            
            if sendSelectArr.count == 10{
                let arrStr = ["全部","采购","调入","退货","生产","调出被拒绝","外采","其他","固定采购","临时采购"]
                sendSArr.removeAll()
                arrStr.forEach { (str) in
                    sendSArr.append(false)
                }
                let statusV = addTitleAndMoreBtn(title: "具体类型", arrStr: arrStr, btnTag: 3000)
                contenV.addSubview(statusV)
                statusV.tag = 10086
                statusV.snp.makeConstraints { (make) in
                    make.left.equalTo(15*glscale)
                    make.top.equalTo(line3.snp_bottom).offset(15*glscale)
                    make.right.equalTo(0)
                    make.height.equalTo(140*glscale)
                }
            }else if sendSelectArr.count == 11{
                let arrStr = ["全部","销售","调出","报损","赠品","自用","生产使用","过期处理","用户试用","采购退货","其他"]
                sendSArr.removeAll()
                arrStr.forEach { (str) in
                    sendSArr.append(false)
                }
                let statusV = addTitleAndMoreBtn(title: "具体类型", arrStr:arrStr,  btnTag: 3000)
                contenV.addSubview(statusV)
                statusV.tag = 10086
                statusV.snp.makeConstraints { (make) in
                    make.left.equalTo(15*glscale)
                    make.top.equalTo(line3.snp_bottom).offset(15*glscale)
                    make.right.equalTo(0)
                    make.height.equalTo(140*glscale)
                }
            }
        }
        
        allSelectBtn.forEach { (sender) in
            if sender.tag < 2000 {
                let i = sender.tag - 1000
                let isBool = paySelectArr[i]
                sender.isSelected = isBool
                if isBool {
                    sender.setTitleColor(UIColor.init(named: "白色背景色"), for: .normal)
                    sender.backgroundColor = UIColor.init(named: "蓝色字体颜色")
                }
                
            }else if sender.tag < 3000 {
                let i = sender.tag - 2000
                let isBool = bugSelectArr[i]
                sender.isSelected = isBool
                if isBool {
                    sender.setTitleColor(UIColor.init(named: "白色背景色"), for: .normal)
                    sender.backgroundColor = UIColor.init(named: "蓝色字体颜色")
                }
                
            }else{
                
                let i = sender.tag - 3000
                let isBool = sendSelectArr[i]
                sender.isSelected = isBool
                if isBool {
                    sender.setTitleColor(UIColor.init(named: "白色背景色"), for: .normal)
                    sender.backgroundColor = UIColor.init(named: "蓝色字体颜色")
                }
            }
            
        }
        
        
    }
    
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        
        
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        
        
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
    
}
