//
//  OrderSelectMoreView.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/4/22.
//  Copyright © 2020 junye lu. All rights reserved.
//

import Foundation
import SwiftDate

protocol OrderSelectMoreViewDelegate {
    func sureAction(beginDate: Date?, endginDate: Date?,paySelectArr:Array<Bool>,bugSelectArr:Array<Bool>,sendSelectArr:Array<Bool>)
    func colseAction()
}
class OrderSelectMoreView: UIView,TitleAndSelCalendarViewDelegate ,TimeSelectViewDelgate{
    var contentView:UIView!
    var delegate:OrderSelectMoreViewDelegate?
    @IBOutlet weak var contentWidht: NSLayoutConstraint!
    @IBOutlet weak var contentHeight: NSLayoutConstraint!
    @IBOutlet weak var moreBgView: UIView!
    
    @IBAction func colseByBlackTap(_ sender: UITapGestureRecognizer) {
        self.removeFromSuperview()
        self.delegate?.colseAction()
    }
    @IBAction func sure(_ sender: UIButton) {
        self.removeFromSuperview()
        self.delegate?.sureAction(beginDate: BeginDate, endginDate: EndDate, paySelectArr: paySArr, bugSelectArr: bugSArr, sendSelectArr: sendSArr)
    }
    @IBAction func reset(_ sender: Any) {
        //重置
        calendarV.clearTheSelect()

        moreBgView.subviews.forEach { (view) in
            view.removeFromSuperview()
        }
        BeginDate = nil
        EndDate = nil
        paySArr = [false,false,false,false,false,false]
        bugSArr = [false,false]
        sendSArr = [false,false,false,false]
        
        setUI()
        self.delegate?.sureAction(beginDate: BeginDate, endginDate: EndDate, paySelectArr: paySArr, bugSelectArr: bugSArr, sendSelectArr: sendSArr)

     }
    
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        setUI()

    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        setUI()

    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
    let line1 = UIView()
    let timeTilelV = TitleAndSelCalendarView()

    func setUI() {
        timeTilelV.delegate = self
        moreBgView.addSubview(timeTilelV)
        timeTilelV.timeLbl.text = "请选择时间范围"
        timeTilelV.isSelectV = false
        timeTilelV.snp.makeConstraints { (make) in
            make.left.top.equalTo(15*glscale)
            make.right.equalTo(-135*glscale)
            make.height.equalTo(60*glscale)
        }
 
        //分界线1
        line1.backgroundColor = UIColor.init(named: "灰色分界线")
        moreBgView.addSubview(line1)
        line1.snp.makeConstraints { (make) in
            make.left.right.equalTo(0)
            make.height.equalTo(1)
            make.top.equalTo(timeTilelV.snp_bottom).offset(15*glscale)
        }
        
        let payV = addTitleAndMoreBtn(title: "支付状态", arrStr: ["未付款","欠款","已付款","月结","已退款","已付定金"], btnTag: 1000)
        moreBgView.addSubview(payV)
        payV.snp.makeConstraints { (make) in
            make.left.equalTo(15*glscale)
            make.top.equalTo(line1.snp_bottom).offset(15*glscale)
            make.right.equalTo(0)
            make.height.equalTo(100*glscale)
        }
        //分界线2
        let line2 = UIView()
        line2.backgroundColor = UIColor.init(named: "灰色分界线")
        moreBgView.addSubview(line2)
        line2.snp.makeConstraints { (make) in
            make.left.right.equalTo(0)
            make.height.equalTo(1)
            make.top.equalTo(payV.snp_bottom).offset(15*glscale)
        }
        let typeV = addTitleAndMoreBtn(title: "下单方式", arrStr: ["自主下单","代客下单"], btnTag: 2000)
        moreBgView.addSubview(typeV)
        typeV.snp.makeConstraints { (make) in
            make.left.equalTo(15*glscale)
            make.top.equalTo(line2.snp_bottom).offset(15*glscale)
            make.right.equalTo(0)
            make.height.equalTo(60*glscale)
        }
        //分界线3
        let line3 = UIView()
        line3.backgroundColor = UIColor.init(named: "灰色分界线")
        moreBgView.addSubview(line3)
        line3.snp.makeConstraints { (make) in
            make.left.right.equalTo(0)
            make.height.equalTo(1)
            make.top.equalTo(typeV.snp_bottom).offset(15*glscale)
        }
        let statusV = addTitleAndMoreBtn(title: "商品配送情况", arrStr: ["未发货","已发货","已收货","已退货"], btnTag: 3000)
        moreBgView.addSubview(statusV)
        statusV.snp.makeConstraints { (make) in
            make.left.equalTo(15*glscale)
            make.top.equalTo(line3.snp_bottom).offset(15*glscale)
            make.right.equalTo(0)
            make.height.equalTo(60*glscale)
        }
        contentWidht.constant = 375*glscale
        contentHeight.constant = 400*glscale
    }
    //MARK--标题和按钮多的情况1
    func addTitleAndMoreBtn(title:String,arrStr:[String],btnTag:Int) -> UIView {
        let conView = UIView()
        
        let titleLbl = UILabel()
        titleLbl.textColor = UIColor.init(named: "标题字颜色")
        titleLbl.font = UIFont.systemFont(ofSize: 13)
        conView.addSubview(titleLbl)
        titleLbl.snp.makeConstraints { (make) in
            make.left.top.equalTo(0)
        }
        titleLbl.text = title
        weak var btn:UIButton? = nil
        for i in 0 ..< arrStr.count {
            let str = arrStr[i]
            let selectBtn = UIButton(type: .custom)
            conView.addSubview(selectBtn)
            selectBtn.setTitle(str, for: .normal)
            selectBtn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
            selectBtn.setTitleColor(UIColor.init(named: "多选按钮字体颜色"), for: .normal)
            selectBtn.backgroundColor = UIColor.init(named: "多选按钮背景颜色")
            selectBtn.layer.cornerRadius = 3
            selectBtn.snp.makeConstraints { (make) in
                if i < 4 {
                    make.left.equalTo(CGFloat(CGFloat(i * (73 + 15)) * glscale))
                    make.top.equalTo(titleLbl.snp_bottom).offset(10*glscale)
                    btn = selectBtn
                }else{
                    make.left.equalTo(CGFloat(CGFloat((i - 4) * (73 + 15)) * glscale))
                    make.top.equalTo(btn!.snp_bottom).offset(10*glscale)
                }
                make.width.equalTo(73*glscale)
                make.height.equalTo(30*glscale)
            }
            selectBtn.addTarget(self, action: #selector(selectBtnAction(sender:)), for: .touchUpInside)
            selectBtn.tag = btnTag + i
            allSelectBtn.append(selectBtn)
        }

        return conView
    }
    @objc func selectBtnAction(sender:UIButton) {
        sender.isSelected = !sender.isSelected
        if sender.isSelected {
            sender.setTitleColor(UIColor.init(named: "白色背景色"), for: .normal)
            sender.backgroundColor = UIColor.init(named: "蓝色字体颜色")
        }else{
            sender.setTitleColor(UIColor.init(named: "多选按钮字体颜色"), for: .normal)
            sender.backgroundColor = UIColor.init(named: "多选按钮背景颜色")
        }
        if sender.tag < 2000 {
            let index = sender.tag - 1000
            paySArr[index] = sender.isSelected
        }else if sender.tag < 3000 {
            let index = sender.tag - 2000
            bugSArr = [false,false]
            allSelectBtn.forEach { (btn) in
                if btn.tag < 3000 && btn.tag > 1999 {
                    if btn.tag != sender.tag {
                        btn.isSelected = false
                        btn.setTitleColor(UIColor.init(named: "多选按钮字体颜色"), for: .normal)
                        btn.backgroundColor = UIColor.init(named: "多选按钮背景颜色")
                    }
                }
            }
            bugSArr[index] = sender.isSelected
        }else{
            let index = sender.tag - 3000
            sendSArr[index] = sender.isSelected
        }
    }
    let calendarV = TimeSelectView(frame: CGRect(x: 0, y: 85*glscale, width: fullScreenWidth, height: 235*glscale))
    //MARK:--展示日历选择器
    func isShowCalendarV(isShow: Bool) {
        if isShow {
            contentHeight.constant = 400*glscale + 235*glscale
            calendarV.moreSelection = true
            moreBgView.addSubview(calendarV)
            calendarV.delegate = self
            line1.snp.remakeConstraints { (make) in
                make.left.right.equalTo(0)
                make.height.equalTo(1)
                make.top.equalTo(calendarV.snp_bottom)
            }
            if BeginDate != nil {
                calendarV.setOldDate(beginD: BeginDate!, endD: EndDate!)
            }

        }else{
            calendarV.removeFromSuperview()
            contentHeight.constant = 400*glscale
            line1.snp.remakeConstraints { (make) in
                make.left.right.equalTo(0)
                make.height.equalTo(1)
                make.top.equalTo(timeTilelV.snp_bottom).offset(15*glscale)
            }
        }
    }
    //MARK:--日历代理
    func selectMoreDate(beginDate: Date, endginDate: Date) {
        //bug
        let timeInterval:TimeInterval = beginDate.timeIntervalSince1970
        let timeIntervalEnd:TimeInterval = endginDate.timeIntervalSince1970

        timeTilelV.timeLbl.text = dayByDouble(sender: timeInterval) + "," + dayByDouble(sender: timeIntervalEnd)
        EndDate = endginDate
        BeginDate = beginDate

    }
    var allSelectBtn : Array<UIButton> = []
    //MARK:--数据源
    var BeginDate: Date! = nil
    var EndDate: Date! = nil
    var paySArr:Array<Bool> = [false,false,false,false,false]
    var bugSArr:Array<Bool> = [false,false]
    var sendSArr:Array<Bool> = [false,false,false,false]
    
    func setUIbyData (beginDate: Date?, endginDate: Date?, paySelectArr: Array<Bool>, bugSelectArr: Array<Bool>, sendSelectArr: Array<Bool>) {
        EndDate = endginDate
        BeginDate = beginDate
        self.paySArr = paySelectArr
        self.bugSArr = bugSelectArr
        self.sendSArr = sendSelectArr
        if BeginDate == nil {
            timeTilelV.timeLbl.text = "请选择时间范围"
        }else{
 
            let timeInterval:TimeInterval = BeginDate.timeIntervalSince1970
            let timeIntervalEnd:TimeInterval = EndDate.timeIntervalSince1970

            timeTilelV.timeLbl.text = dayByDouble(sender: timeInterval) + "," + dayByDouble(sender: timeIntervalEnd)
        }
        allSelectBtn.forEach { (sender) in
            if sender.tag < 2000 {
                let i = sender.tag - 1000
                let isBool = paySelectArr[i]
                sender.isSelected = isBool
                if isBool {
                    sender.setTitleColor(UIColor.init(named: "白色背景色"), for: .normal)
                    sender.backgroundColor = UIColor.init(named: "蓝色字体颜色")
                }
                
            }else if sender.tag < 3000 {
                let i = sender.tag - 2000
                let isBool = bugSelectArr[i]
                sender.isSelected = isBool
                if isBool {
                    sender.setTitleColor(UIColor.init(named: "白色背景色"), for: .normal)
                    sender.backgroundColor = UIColor.init(named: "蓝色字体颜色")
                }
                
            }else{
                let i = sender.tag - 3000
                let isBool = sendSelectArr[i]
                sender.isSelected = isBool
                if isBool {
                    sender.setTitleColor(UIColor.init(named: "白色背景色"), for: .normal)
                    sender.backgroundColor = UIColor.init(named: "蓝色字体颜色")
                }
            }
     
        }


    }

}
