//
//  NavBarView.swift
//  GeLiLaiGeWan
//
//  Created by geli on 2018/7/20.
//  Copyright © 2018年 geli. All rights reserved.
//

import UIKit
import SnapKit

@objc protocol NavBarViewDelegate {
    @objc optional func backAction()
    @objc optional func rightBtnClick()
}

class NavBarView: BaseView {
    var deleagte:NavBarViewDelegate?
    var title:String?{
        didSet{
            titleLbl.text = title
        }
    }
    
    var rightImg:UIImage?{
        didSet{
            rightBtn.setImage(rightImg, for: .normal)
            rightBtn.snp.makeConstraints { (make) in
                make.right.equalTo(-12)
                make.bottom.equalTo(-14)
            }
        }
    }
    var rightTitle:String?{
        didSet{
            rightBtn.setTitle(rightTitle, for: .normal)
            rightBtn.titleLabel?.font = setFont(14)
            rightBtn.sizeToFit()
            rightBtn.setTitleColor(UIColor(named: "按钮渐变色下,字体颜色"), for: .normal)
            rightBtn.snp.makeConstraints { (make) in
                make.right.equalTo(-12)
                make.bottom.equalTo(-7)
            }
        }
    }
    var rightBtnColor:UIColor?{
        didSet{
           rightBtn.setTitleColor(rightBtnColor, for: .normal)
        }
    }
    var leftImg:UIImage?{
        didSet{
            leftImgV.image = leftImg
        }
    }
    var leftTitle:String?{
        didSet{
            leftBtn.setTitle(leftTitle, for: .normal)
            leftBtn.sizeToFit()
            leftBtn.snp.makeConstraints { (make) in
                make.left.equalTo(12)
                make.bottom.equalTo(-14)
            }
        }
    }
    var lineView:UIView!
    var leftImgV:UIImageView!
    var titleLbl:UILabel!
    
    private
    var rightBtn:UIButton!
    var leftBtn:UIButton!
 
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        self.backgroundColor = UIColor.white
        titleLbl = UILabel()
        titleLbl.font = setFont(18)
        titleLbl.textColor = UIColor(named: "标题字颜色")
        titleLbl.textAlignment = .center
        self.addSubview(titleLbl)
        titleLbl.snp.makeConstraints { (make) in
            make.bottom.left.right.equalToSuperview()
            make.height.equalTo(44)
        }
        
        leftImgV = UIImageView()
        leftImgV.image = UIImage(named: "fanhui")
        self.addSubview(leftImgV)
        leftImgV.snp.makeConstraints { (make) in
            make.left.equalTo(12)
            make.bottom.equalTo(-14)
            make.width.equalTo(10)
            make.height.equalTo(17)
        }
        
        leftBtn = UIButton(frame: CGRect(x: 0, y: 0, width: 60, height: frame.size.height))
        
        leftBtn.addTarget(self, action: #selector(backAction), for: .touchUpInside)
        self.addSubview(leftBtn)
        
        rightBtn = UIButton()
        rightBtn.addTarget(self, action: #selector(rightClick), for: .touchUpInside)
        self.addSubview(rightBtn)
        
        lineView = UIView(frame: CGRect(x: 0, y: frame.size.height-1, width: frame.size.width, height: 1))
        lineView.backgroundColor = RGB(r: 244, g: 244, b: 244)
        self.addSubview(lineView)
    }
    
   
    
    @objc func backAction(){
        deleagte?.backAction!()
        if leftImgV.isHidden == false {
            self.superview?.inputViewController?.navigationController?.popViewController(animated: true)
        }
    }

    @objc func rightClick(){
        deleagte?.rightBtnClick!()
    }
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
}
