//
//  PaymentView.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/8/4.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol PaymentViewDelegate {
    func PaymentViewClose()
    func PaymentViewPassInputFinish(fullpass:String)
}
class PaymentView: UIView, PasswordViewDelegate {
    var price:Float?{
        didSet{
            let str = "¥ \(price!)"
            let attributeString = NSMutableAttributedString(string:str)
            attributeString.addAttribute(NSAttributedString.Key.font, value: UIFont(name: "PingFangSC-Medium", size: 18)!,range: NSMakeRange(0,1))
            attributeString.addAttribute(NSAttributedString.Key.font, value: UIFont(name: "PingFangSC-Medium", size: 30)!,range: NSMakeRange(1,str.count-1))
            priceLbl.attributedText = attributeString
        }
    }
    @IBOutlet weak var bgView: UIView!
    @IBOutlet weak var passBG: UIView!
    var delegate:PaymentViewDelegate?
    @IBAction func closeAction(_ sender: UIButton) {
        delegate?.PaymentViewClose()
    }
    
    @IBOutlet weak var priceLbl: UILabel!
    var contentView:UIView!
    
    
    
    func passwordView(textFinished: String) {
        print("输入完成: \(textFinished)")
        delegate?.PaymentViewPassInputFinish(fullpass: textFinished)
    }
    
    func passwordView(textChanged: String, length: Int) {
        print("文本改变: \(textChanged), length: \(length)")
    }
    
    
    func setUI(){
        let passwordView = PayPassView(frame:passBG.bounds)
        passwordView.backgroundColor = UIColor.white
        passwordView.delegate = self
        passwordView.maxLength = 6
        passBG.addSubview(passwordView)
        
    }
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        setUI()
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        setUI()
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
    
}
