//
//  SearchBarView.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/4/22.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol SearchBarViewDelegate {
    func clearSearchAction()
}
class SearchBarView: UISearchBar {

    var delegateL: SearchBarViewDelegate?
  
    override init(frame: CGRect) {
        super.init(frame: frame)
        setInit()

    }
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        setInit()
    }

    var placeholderStr: String?{
        didSet{
            print("didset")
            changePlstr(placeStr: placeholderStr)
        }
    }
    
    var cornerRadius:CGFloat = 0{
        didSet{
            changecornerRadius(cornerRadius: cornerRadius)
        }
    }
    
    //初始设置
    func setInit() {
        self.searchBarStyle = .minimal
        self.backgroundColor = UIColor.init(named: "白色背景色")
        self.setPositionAdjustment(UIOffset(horizontal: 10, vertical: 0), for: .search)
        self.setImage(UIImage.init(named: "sousuo"), for: .search, state: .normal)
        self.placeholder = "搜索相关关键字"
        let searchField: UITextField = self.value(forKey: "searchField") as! UITextField
        searchField.textColor = UIColor.init(named: "标题字颜色")
        searchField.clipsToBounds = true
//        searchField.backgroundColor = UIColor.init(named: "搜索框底色")
        
        clearAction()
    }
 
    //修改圆角
    func changecornerRadius(cornerRadius:CGFloat) {
 
        let searchField: UITextField = self.value(forKey: "searchField") as! UITextField //先找到输入框控件：UITextField
        searchField.layer.cornerRadius = cornerRadius

    }

    //修改占位字
    func changePlstr(placeStr:String?) {
 
        let searchField: UITextField = self.value(forKey: "searchField") as! UITextField //先找到输入框控件：UITextField
        let str = NSAttributedString.init(string: placeStr!, attributes: [NSAttributedString.Key.font:UIFont.systemFont(ofSize: 13)])
        searchField.attributedPlaceholder = str
    }
    
    //叉号触发
    func clearAction() {
        let searchField: UITextField = self.value(forKey: "searchField") as! UITextField //先找到输入框控件：UITextField
        let clearBtn: UIButton = searchField.value(forKey: "_clearButton") as! UIButton //输入框中按钮：UIButton
        clearBtn.addTarget(self, action: #selector(clearBtnClick), for: .touchUpInside)//给按钮添加事件
    }
    
    //按钮事件方法
    @objc fileprivate func clearBtnClick() {
        //TODO
        print("清除触发")
        self.delegateL?.clearSearchAction()
    }
    
}
