//
//  ShowTimeSelectView.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/5/18.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

protocol ShowTimeSelectViewDelegate {
    func showTimeSelectByData(timeStr:String,beginDate: Date, endginDate: Date)
}

class ShowTimeSelectView: UIView ,TimeSelectViewDelgate{
    override init(frame: CGRect) {
        super.init(frame: frame)
        self.backgroundColor = UIColor.clear
        blackView.backgroundColor = UIColor.init(named: "提示视图背景色")
        blackView.addTarget(self, action: #selector(hideAction(sender:)), for: .touchUpInside)

        self.addSubview(blackView)
        blackView.snp.makeConstraints { (make) in
            make.left.top.bottom.right.equalToSuperview()
        }
        self.addSubview(contetV)
        self.addSubview(sureBtn)
        
        contetV.backgroundColor = UIColor.white
        contetV.layer.cornerRadius = 5
        contetV.snp.makeConstraints { (make) in
            make.left.right.equalToSuperview()
            make.bottom.equalTo(sureBtn.snp_top).offset(3*glscale)
            make.height.equalTo(340*glscale)
        }
        
        sureBtn.snp.makeConstraints { (make) in
            make.left.right.bottom.equalToSuperview()
            make.height.equalTo(TabHeight)
        }


        sureBtn.setTitle("确定", for: .normal)
        sureBtn.addTarget(self, action: #selector(sureAction(sender:)), for: .touchUpInside)
        sureBtn.backgroundColor = UIColor.init(named: "蓝色字体颜色")
        sureBtn.setTitleColor(UIColor.white, for: .normal)
        sureBtn.titleLabel?.font = UIFont.boldSystemFont(ofSize: 17)

        titleLbl.text = "选择时间段"
        titleLbl.textColor = UIColor.init(named: "标题字颜色")
        titleLbl.font = UIFont.boldSystemFont(ofSize: 15)
        contetV.addSubview(titleLbl)
        titleLbl.snp.makeConstraints { (make) in
            make.top.equalTo(15*glscale)
            make.centerX.equalToSuperview()
        }

        let lineV =  UIView()
        lineV.backgroundColor = UIColor.init(named: "灰色分界线")
        contetV.addSubview(lineV)
        lineV.snp.makeConstraints { (make) in
            make.left.right.equalToSuperview()
            make.top.equalTo(titleLbl.snp_bottom).offset(15*glscale)
            make.height.equalTo(1)
        }

        let kuangV = UIView()
        kuangV.layer.borderColor = UIColor.init(named: "灰色字体颜色")?.cgColor
        kuangV.layer.borderWidth = 1
        kuangV.layer.cornerRadius = 3
        contetV.addSubview(kuangV)
        kuangV.snp.makeConstraints { (make) in
            make.height.equalTo(32*glscale)
            make.width.equalTo(180*glscale)
            make.left.equalTo(15*glscale)
            make.top.equalTo(lineV.snp_bottom).offset(15*glscale)
        }

        clearBtn.setImage(UIImage.init(named: "workTimeDel"), for: .normal)
        clearBtn.addTarget(self, action: #selector(clearBtnAction(sender:)), for: .touchUpInside)
        contetV.addSubview(clearBtn)
        clearBtn.snp.makeConstraints { (make) in
            make.right.equalTo(kuangV.snp_right).offset(-7*glscale)
            make.centerY.equalTo(kuangV)
        }

        timeLbl.text = "-"
        timeLbl.font = UIFont.systemFont(ofSize: 13)
        timeLbl.textColor = UIColor.init(named: "标题字颜色")
        contetV.addSubview(timeLbl)
        timeLbl.snp.makeConstraints { (make) in
            make.centerY.equalTo(kuangV)
            make.left.equalTo(kuangV.snp_left).offset(10*glscale)
        }
        calendarV.moreSelection = moreSelection
        contetV.addSubview(calendarV)
        calendarV.delegate = self
        
    }
    var moreSelection:Bool = true {
        didSet {
            calendarV.moreSelection = moreSelection

        }
    }
    let blackView =  UIButton(type: .custom)
    let sureBtn = UIButton(type: .custom)
    let contetV = UIView()
    let titleLbl = UILabel()
    let timeLbl = UILabel()
    let clearBtn = UIButton(type: .custom)
    let calendarV = TimeSelectView(frame: CGRect(x: 0, y: 105*glscale, width: fullScreenWidth, height: 235*glscale))
    var delegate : ShowTimeSelectViewDelegate?
    var beginDateByWork: Date? = nil {
        didSet {
            calendarV.beginDateByWork = beginDateByWork
            if BeginDate != nil && EndDate != nil {
                calendarV.setOldDate(beginD: BeginDate, endD: EndDate)
                let timeInterval:TimeInterval = BeginDate.timeIntervalSince1970
                let timeIntervalEnd:TimeInterval = EndDate.timeIntervalSince1970
                timeLbl.text = dayByDouble(sender: timeInterval) + "-" + dayByDouble(sender: timeIntervalEnd)
            }

        }
    }
    var endDateByWork: Date? = nil {
        didSet {
            calendarV.endDateByWork = endDateByWork
            if BeginDate != nil{
                calendarV.setOldDate(beginD: BeginDate, endD: BeginDate)
                let timeInterval:TimeInterval = BeginDate.timeIntervalSince1970
                timeLbl.text = dayByDouble(sender: timeInterval)
            }
        }
    }

    var BeginDate: Date! = nil
    var EndDate: Date! = nil 
    func selectMoreDate(beginDate: Date, endginDate: Date) {
        print("选择日期·····")
        if moreSelection {
            let timeInterval:TimeInterval = beginDate.timeIntervalSince1970
            let timeIntervalEnd:TimeInterval = endginDate.timeIntervalSince1970
            timeLbl.text = dayByDouble(sender: timeInterval) + "-" + dayByDouble(sender: timeIntervalEnd)
            EndDate = endginDate
            BeginDate = beginDate
        }else{
            //单选
            let timeInterval:TimeInterval = beginDate.timeIntervalSince1970
            timeLbl.text = dayByDouble(sender: timeInterval)
            EndDate = endginDate
            BeginDate = beginDate
        }

    }
    @objc func sureAction(sender:UIButton) {
        print("确定日期·····")
        if moreSelection {
            if EndDate == nil {
                HUD.flash(.label("请选择时间段"), delay: 1.2)
                return
            }
        }else{
            //单选
            if BeginDate == nil {
                HUD.flash(.label("请选择时间"), delay: 1.2)
                return
            }
        }

        self.delegate?.showTimeSelectByData(timeStr: timeLbl.text!, beginDate: BeginDate, endginDate: EndDate)
        self.removeFromSuperview()

    }
    @objc func clearBtnAction(sender:UIButton){
        print("清除日期·····")
        EndDate = nil
        BeginDate = nil
        timeLbl.text = "-"
        calendarV.clearTheSelect()

    }
    @objc func hideAction(sender:UIButton){
        self.removeFromSuperview()
    }
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        
    }
}
