//
//  TimeShowDownView.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/11/3.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

protocol TimeShowDownViewDeleagte {
    func TimeShowDownViewRemoveForSup()

}

class TimeShowDownView: UIView,TimeSelectViewDelgate {
    var delegate:TimeShowDownViewDeleagte?

    @IBAction func resetAction(_ sender: UIButton) {
        self.delegate?.TimeShowDownViewRemoveForSup()
        self.removeFromSuperview()
    }
    
    @IBAction func sureAction(_ sender: UIButton) {
        self.delegate?.TimeShowDownViewRemoveForSup()
        self.removeFromSuperview()
    }
    @IBAction func balckTapAction(_ sender: UITapGestureRecognizer) {
        self.delegate?.TimeShowDownViewRemoveForSup()
        self.removeFromSuperview()
    }
    var BeginDate: Date! = nil
    var EndDate: Date! = nil 
    func selectMoreDate(beginDate: Date, endginDate: Date) {
        let timeInterval:TimeInterval = beginDate.timeIntervalSince1970
        let timeIntervalEnd:TimeInterval = endginDate.timeIntervalSince1970
        startTimeBtn.setTitle(dayByDouble(sender: timeInterval), for: .normal)
        endTimeBtn.setTitle(dayByDouble(sender: timeIntervalEnd), for: .normal)
        EndDate = endginDate
        BeginDate = beginDate
        
    }
    @IBOutlet weak var startTimeBtn: UIButton!
    @IBOutlet weak var endTimeBtn: UIButton!
    
    var contentView:UIView!

    @IBOutlet weak var timeBgView: UIView!
    weak var CalendarV:TimeSelectView?

    func addTimeView() {

        let calendarV = TimeSelectView(frame: CGRect(x: 0, y: 8, width: fullScreenWidth, height: 230*glscale))
        calendarV.moreSelection = true
        timeBgView.addSubview(calendarV)
        calendarV.delegate = self
        CalendarV = calendarV
    }
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        addTimeView()
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        addTimeView()
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }

}
